{ Demonstration program for ChroMathsome - Linear Algebra.

  This demo shows how to use a stringgrid as an interface for entering matrices/vectors.
  Also demonstrated are the file i/o functions of ChroMathsome - Linear Algebra.

  Read the help file for information about the implemented functions
  and their limitations/possibilities!!!

  Author: John Merrit (john.merrit@net4all.be)
  Release date: June 30, 1998
  Reader may do with this code whatever he/she wants.

  ChroMathsome - Linear Algebra 1996-98 John Merrit

  Disclaimer:
  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
  WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

  Brought to you by the letter "E".
  "Progress has no patience - but something's got to give"              }
unit usemdlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, LinAlg, MatrxDlg, ComCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Close1: TMenuItem;
    Matrix1: TMenuItem;
    EnterRealMatrix1: TMenuItem;
    Vector1: TMenuItem;
    SavetoFile1: TMenuItem;
    LoadfromFile1: TMenuItem;
    RealMatrix1: TMenuItem;
    ComplexMatrix1: TMenuItem;
    RealMatrix2: TMenuItem;
    ComplexMatrix2: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Memo1: TRichEdit;
    SavetoFile2: TMenuItem;
    LoadfromFile2: TMenuItem;
    RealVector1: TMenuItem;
    ComplexVector1: TMenuItem;
    RealVector2: TMenuItem;
    ComplexVector2: TMenuItem;
    procedure Close1Click(Sender: TObject);
    procedure EnterMatrix(Sender: TObject);
    procedure RealMatrix1Click(Sender: TObject);
    procedure RealMatrix2Click(Sender: TObject);
    procedure SaveVector(Sender: TObject);
    procedure LoadVector(Sender: TObject);
  private
    { Private declarations }
    procedure Write_Message(s: string);
    procedure Write_RealMatrix(M: RealMatrix);
    procedure Write_ComplexMatrix(M: ComplexMatrix);
    procedure Write_RealVector(V: RealVector);
    procedure Write_ComplexVector(V: ComplexVector);

    procedure RetrieveRealMatrix(var M: RealMatrix);
    
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Close1Click(Sender: TObject);
begin
     Close;
end;

procedure TForm1.Write_Message(s: string);
begin
     Memo1.Lines.add(s);
end;

{ Write a real matrix to the screen, creating a nice readable look.
  Note that to reach a specified element in a matrix/vector, you must use carets (^).}
procedure TForm1.Write_RealMatrix(M: RealMatrix);
var a,b:integer;
    matt,mats,mattt:string;
begin
    memo1.Enabled:= true;
    mattt:= '';
    for a:= 1  to M.Row do
    begin
    mats:= '[ ';
    for b:= 1 to M.Col do
    begin  { below, you see the carets }
    if abs(M.Matrix^[a]^[b]) < 1E-17 then
    begin
    M.Matrix^[a]^[b]:= 0;
    matt:= '0';
    end
    else
    matt:= FloatToStrF(M.Matrix^[a]^[b], ffexponent,10,2);
    mattt:= mattt + matt + ' ';
    end;
    mats:= mats + mattt + ']';
    mattt:= '';
    memo1.Lines.add(mats);
    end;
end;

{ Complex counterpart of above. }
procedure TForm1.Write_ComplexMatrix(M: ComplexMatrix);
var a,b:integer;
    matt,mats,mattt:string;
    c,d: extended;
begin
    Memo1.Enabled:= true;
    mattt:= '';
    for a:= 1  to M.Row do
    begin
    mats:= '[ ';
    for b:= 1 to M.Col do
    begin
    c:= M.Matrix^[a]^[b].re;
    if abs(c) < 1E-12 then c:= 0;
    d:= M.Matrix^[a]^[b].im;
    if abs(d) < 1E-12 then d:= 0;
    matt:= '(' + FloatToStr(c) + ';' + FloatToStr(d) + ')';
    mattt:= mattt + matt + ' ';
    end;
    mats:= mats + mattt + ']';
    mattt:= '';
    Memo1.Lines.add(mats);
    end;
end;

{ Write a real vector to the screen, creating a nice readable look. }
procedure TForm1.Write_RealVector(V: RealVector);
var a:integer;
    matt,mats,mattt:string;
begin
    Memo1.Enabled:= true;
    mattt:= '';
    mats:= '[ ';
    for a:= 1 to V.Dimension do
    begin
    if abs(V.Vector^[a]) < 1E-17 then
    begin
    V.Vector^[a]:= 0;
    matt:= IntToStr(round(V.Vector^[a]));
    end
    else
    matt:= FloatToStrF(V.Vector^[a], ffexponent,5,2);
    mattt:= mattt + matt + ' ';
    end;
    mats:= mats + mattt + ']';
    Memo1.Lines.add(mats);
end;

{ Complex counterpart of above. }
procedure TForm1.Write_ComplexVector(V: ComplexVector);
var a:integer;
    matt,mats,mattt:string;
begin
    Memo1.Enabled:= true;
    mattt:= '';
    mats:= '[ ';
    for a:= 1 to V.Dimension do
    begin
    matt:= '(' + FloatToStr(V.Vector^[a].re) + ';' +  FloatToStr(V.Vector^[a].im) + ')';
    mattt:= mattt + matt + ' ';
    end;
    mats:= mats + mattt + ']';
    Memo1.Lines.add(mats);
end;

{ Retrieve a matrix.
  Matrix will be constructed using the values entered in the MatrixDlg. }
procedure TForm1.RetrieveRealMatrix(var M: RealMatrix);
var i, j, Row, Col: integer;
    x: extended;
begin
     Row:= MatrxDLG.EnterMatrixDlg.MatrixGrid.RowCount;
     Col:= MatrxDLG.EnterMatrixDlg.MatrixGrid.ColCount;
     Redimension_RealMatrix(M, Row - 1, Col - 1);
     for i:= 1 to M.Row do
     for j:= 1 to M.Col do
     begin
     x:= StrToFloat(MatrxDLG.EnterMatrixDlg.MatrixGrid.Cells[j,i]);
     M.Matrix^[i]^[j]:= x;
     end;
end;

procedure TForm1.EnterMatrix(Sender: TObject);
var RM: RealMatrix;
begin
     InitRealMatrix(RM, 1, 1);

     if MatrxDlg.EnterMatrixDlg.ShowModal = id_OK then
      begin
      RetrieveRealMatrix(RM);
      Write_Message('Entered matrix: ');
      Write_RealMatrix(RM);
      end;

     DestroyRealMatrix(RM);
end;


{ Saving a matrix to a file. }
procedure TForm1.RealMatrix1Click(Sender: TObject);
var RM: RealMatrix;
    CM: ComplexMatrix;
    ComplexM: boolean;
begin
     if SaveDialog1.Execute then
     begin
         if Sender = RealMatrix1 then ComplexM:= false else ComplexM:= true;
         { Store matrix M in a (text) file. }
         if ComplexM = false then
         begin
           InitRealMatrix(RM, 13, 7);
           Random_RealMatrix(RM, 1000);
           SaveRealMatrixToFile(RM, SaveDialog1.FileName);
           Write_Message('Saved matrix: ');
           Write_RealMatrix(RM);
         end
         else
         begin
            InitComplexMatrix(CM, 13, 7);
            Random_ComplexMatrix(CM, 1000);
            SaveComplexMatrixToFile(CM, SaveDialog1.FileName);
            Write_Message('Saved matrix: ');
            Write_ComplexMatrix(CM);
         end;
      if ComplexM = false then DestroyRealMatrix(RM)
      else DestroyComplexMatrix(CM);
     end;
end;

{ Loading a matrix from a file. }
procedure TForm1.RealMatrix2Click(Sender: TObject);
var RM: RealMatrix;
    CM: ComplexMatrix;
    ComplexM: boolean;
begin
     if OpenDialog1.Execute then
     begin
         if Sender = RealMatrix2 then ComplexM:= false else ComplexM:= true;
         { Load matrix M from a (text) file. }
         if ComplexM = false then
         begin
           InitRealMatrix(RM, 1, 1);
           LoadRealMatrixFromFile(RM, OpenDialog1.FileName);
           Write_Message('Loaded matrix: ');
           Write_RealMatrix(RM);
         end
         else
         begin
            InitComplexMatrix(CM, 1, 1);
            LoadComplexMatrixFromFile(CM, OpenDialog1.FileName);
            Write_Message('Loaded matrix: ');
            Write_ComplexMatrix(CM);
         end;
      if ComplexM = false then DestroyRealMatrix(RM)
      else DestroyComplexMatrix(CM);
     end;
end;

procedure TForm1.SaveVector(Sender: TObject);
var RV: RealVector;
    CV: ComplexVector;
    ComplexV: boolean;
begin
     if SaveDialog1.Execute then
     begin
         if Sender = RealVector1 then ComplexV:= false else ComplexV:= true;
         { Store vector V in a (text) file. }
         if ComplexV = false then
         begin
           InitRealVector(RV, 13);
           Random_RealVector(RV, 1000);
           SaveRealVectorToFile(RV, SaveDialog1.FileName);
           Write_Message('Saved vector: ');
           Write_RealVector(RV);
         end
         else
         begin
            InitComplexVector(CV, 13);
            Random_ComplexVector(CV, 1000);
            SaveComplexVectorToFile(CV, SaveDialog1.FileName);
            Write_Message('Saved vector: ');
            Write_ComplexVector(CV);
         end;
      if ComplexV = false then DestroyRealVector(RV)
      else DestroyComplexVector(CV);
     end;
end;

procedure TForm1.LoadVector(Sender: TObject);
var RV: RealVector;
    CV: ComplexVector;
    ComplexV: boolean;
begin
     if OpenDialog1.Execute then
     begin
         if Sender = RealVector2 then ComplexV:= false else ComplexV:= true;
         { Load vector V from a (text) file. }
         if ComplexV = false then
         begin
           InitRealVector(RV, 1);
           LoadRealVectorFromFile(RV, OpenDialog1.FileName);
           Write_Message('Loaded vector: ');
           Write_RealVector(RV);
         end
         else
         begin
            InitComplexVector(CV, 1);
            LoadComplexVectorFromFile(CV, OpenDialog1.FileName);
            Write_Message('Loaded vector: ');
            Write_ComplexVector(CV);
         end;
      if ComplexV = false then DestroyRealVector(RV)
      else DestroyComplexVector(CV);
     end;
end;

end.
